/* ==================================================================================================================
 *
 *  CEBhEvV[W
 *
 ================================================================================================================== */

#include <windows.h>
#include <stdio.h>
#include "prime.h"
#include "WndMain.h"
#include "resource.h"



// bZ[W֐^
typedef BOOL (*MSG_FUNC)(HWND, WPARAM, LPARAM, LRESULT*);
// bZ[W֐\
typedef struct {
	UINT     msg_id;
	MSG_FUNC msg_func;
} MSG_TABLE, *LPMSG_TABLE;
// Rg[֐^
typedef BOOL (*CTRL_FUNC)(HWND, HWND, WORD, WORD, LRESULT*);
// Rg[֐\
typedef struct {
	UINT      ctrl_id;
	CTRL_FUNC ctrl_func;
} CTRL_TABLE, *LPCTRL_TABLE;







// vg^Cv
static BOOL OnCommand(HWND hwnd, WPARAM wp, LPARAM lp, LRESULT* pResult);
static BOOL WINAPI WndMainProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);






/* ------------------------------------------------------------------------------------------------------
	EBhE쐬
------------------------------------------------------------------------------------------------------ */
HWND CreateMainWindow(HINSTANCE hInstance, HWND hOwner)
{
	return CreateDialogParam(hInstance, MAKEINTRESOURCE(IDD_DLGMAIN), hOwner, WndMainProc, 0);
}






///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//               ebZ[W֐
//

/* ------------------------------------------------------------------------------------------------------
	WM_DESTROY
------------------------------------------------------------------------------------------------------ */
static BOOL OnDestroy(HWND hwnd, WPARAM wp, LPARAM lp, LRESULT* pResult)
{
	PostQuitMessage(0);
	return TRUE;
}

/* ------------------------------------------------------------------------------------------------------
	WM_CLOSE
------------------------------------------------------------------------------------------------------ */
static BOOL OnClose(HWND hwnd, WPARAM wp, LPARAM lp, LRESULT* pResult)
{
	pmStop();
	pmStopSingle();
	Sleep(100);
	DestroyWindow( hwnd );
	return FALSE;
}

/* ------------------------------------------------------------------------------------------------------
	WM_INITDIALOG
------------------------------------------------------------------------------------------------------ */
static BOOL OnCreate(HWND hwnd, WPARAM wp, LPARAM lp, LRESULT* pResult)
{
	char szNow[256]="";
	char szCount[256]="";
	GetPrivateProfileString(PM_APP, PM_KEY_NOW, "2", szNow, sizeof(szNow)-1, PM_SETFILE);
	GetPrivateProfileString(PM_APP, PM_KEY_COUNT, "0", szCount, sizeof(szCount)-1, PM_SETFILE);
	SetDlgItemText(hwnd, IDC_NOW  , szNow);
	SetDlgItemText(hwnd, IDC_COUNT, szCount);
	ShowWindow(hwnd, SW_SHOW);
	return TRUE;
}

/* ------------------------------------------------------------------------------------------------------
	WM_NOTIFY
------------------------------------------------------------------------------------------------------ */
static BOOL OnNotify(HWND hwnd, WPARAM wp, LPARAM lp, LRESULT* pResult)
{
	LPNMHDR nmhdr          = (LPNMHDR)lp;
	return FALSE;
}







///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//               eRg[֐
//

/* ------------------------------------------------------------------------------------------------------
	IDOK
------------------------------------------------------------------------------------------------------ */
static BOOL OnOK(HWND hwnd, HWND hCtrl, WORD wID, WORD wNotify, LRESULT* pResult)
{
	if( pmIsPrimeThread() )
	{
		pmStop();
		SetDlgItemText(hwnd, IDOK, "Jn(&X)");
	}
	else
	{
		ULONGLONG nNow   = GetPrivateProfileInt64(PM_APP, PM_KEY_NOW  , 2, PM_SETFILE);
		ULONGLONG nCount = GetPrivateProfileInt64(PM_APP, PM_KEY_COUNT, 0, PM_SETFILE);
		pmStart(hwnd, nNow, nCount);
		SetDlgItemText(hwnd, IDOK, "~(&X)");
	}
	return TRUE;
}

/* ------------------------------------------------------------------------------------------------------
	IDCANCEL
------------------------------------------------------------------------------------------------------ */
static BOOL OnCancel(HWND hwnd, HWND hCtrl, WORD wID, WORD wNotify, LRESULT* pResult)
{
	SendMessage(hwnd, WM_CLOSE, 0, 0);
	return TRUE;
}

/* ------------------------------------------------------------------------------------------------------
	IDC_CHECK
------------------------------------------------------------------------------------------------------ */
static BOOL OnCheck(HWND hwnd, HWND hCtrl, WORD wID, WORD wNotify, LRESULT* pResult)
{
	if( pmIsPrimeThreadSingle() )
	{
		pmStopSingle();
		//SetDlgItemText(hwnd, IDC_CHECK, "(&C)");
	}
	else
	{
		pmStartSingle(hwnd);
		//SetDlgItemText(hwnd, IDC_CHECK, "~(&C)");
	}
	return TRUE;
}



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//             bZ[Wnhe[u`
//
//
static const MSG_TABLE msg_handler[] = {
	{WM_DESTROY         , OnDestroy},
	{WM_CLOSE           , OnClose},
	{WM_INITDIALOG      , OnCreate},
	{WM_NOTIFY          , OnNotify},
	{WM_COMMAND         , OnCommand},
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//             Rg[nhe[u`
//
static const CTRL_TABLE ctrl_handler[] = {
	{IDOK               , OnOK},
	{IDCANCEL           , OnCancel},
	{IDC_CHECK          , OnCheck},
};


/* ------------------------------------------------------------------------------------------------------
	CEBhEv[W
------------------------------------------------------------------------------------------------------ */
static BOOL WINAPI WndMainProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	LRESULT result=TRUE;
	static const int table_max = sizeof(msg_handler) / sizeof(msg_handler[0]);

	for(int i=0; i < table_max; i++)
	{
		if( msg_handler[i].msg_id == msg )
		{
			if( msg_handler[i].msg_func &&
				msg_handler[i].msg_func(hwnd, wp, lp, &result) )
				return (BOOL)result;
			break;
		}
	}
	return FALSE;
}


/* ------------------------------------------------------------------------------------------------------
	WM_COMMAND
------------------------------------------------------------------------------------------------------ */
static BOOL OnCommand(HWND hwnd, WPARAM wp, LPARAM lp, LRESULT* pResult)
{
	UINT ctrl = LOWORD(wp);

	static const int table_max = sizeof(ctrl_handler) / sizeof(ctrl_handler[0]);

	// Rg[nh
	for(int i=0; i < table_max; i++)
	{
		// Rg[֐
		if( ctrl_handler[i].ctrl_id == ctrl &&
			ctrl_handler[i].ctrl_func )
			return ctrl_handler[i].ctrl_func(hwnd, (HWND)lp, LOWORD(wp), HIWORD(wp), pResult);
	}
	return FALSE;
}
