/* ==================================================================================================================
 *
 *  f
 *
 ================================================================================================================== */

#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <math.h>
#include "prime.h"
#include "resource.h"


static BOOL isPrimeThread;
static BOOL isPrimeThreadSingle;
static ULONGLONG nPrimeNow;
static ULONGLONG nPrimeCount;

static void pmWriteNow(ULONGLONG nNow, ULONGLONG nCount);
static ULONGLONG pmSqrt64(ULONGLONG nNumber);
static int pmIsPrime(ULONGLONG nPrime);
static void pmSearch(void* pParam);
static void pmSearchSingle(void* pParam);


/* ------------------------------------------------------------------------------------------------------
	ini琔l擾 64bit
------------------------------------------------------------------------------------------------------ */
ULONGLONG GetPrivateProfileInt64(LPCSTR lpAppName, LPCSTR lpKeyName, ULONGLONG nDefault, LPCSTR lpFileName)
{
	char szData[256]="";
	char szDef[256]="";
	_ui64toa(nDefault, szDef, 10);
	GetPrivateProfileString(lpAppName, lpKeyName, szDef, szData, sizeof(szData)-1, lpFileName);
	return _strtoui64(szData, NULL, 10);
}

/* ------------------------------------------------------------------------------------------------------
	ini֐l 64bit
------------------------------------------------------------------------------------------------------ */
BOOL WritePrivateProfileInt64(LPCSTR lpAppName, LPCSTR lpKeyName, ULONGLONG nData, LPCSTR lpFileName)
{
	char szData[256]="";
	_ui64toa(nData, szData, 10);
	return WritePrivateProfileString(lpAppName, lpKeyName, szData, lpFileName);
}

/* ------------------------------------------------------------------------------------------------------
	XbhX^[g
------------------------------------------------------------------------------------------------------ */
BOOL pmStart(HWND hwnd, ULONGLONG nNow, ULONGLONG nCount)
{
	if( isPrimeThread ) return TRUE;
	isPrimeThread = TRUE;
	nPrimeNow     = nNow;
	nPrimeCount   = nCount;
	_beginthread(pmSearch, 0, hwnd);
	return TRUE;
}

/* ------------------------------------------------------------------------------------------------------
	XbhXgbv
------------------------------------------------------------------------------------------------------ */
void pmStop(void)
{
	isPrimeThread = FALSE;
}

/* ------------------------------------------------------------------------------------------------------
	XbhĂ邩
------------------------------------------------------------------------------------------------------ */
BOOL pmIsPrimeThread(void)
{
	return isPrimeThread;
}

/* ------------------------------------------------------------------------------------------------------
	PXbhX^[g
------------------------------------------------------------------------------------------------------ */
BOOL pmStartSingle(HWND hwnd)
{
	if( isPrimeThreadSingle ) return TRUE;
	isPrimeThreadSingle = TRUE;
	_beginthread(pmSearchSingle, 0, hwnd);
	return TRUE;
}

/* ------------------------------------------------------------------------------------------------------
	PXbhXgbv
------------------------------------------------------------------------------------------------------ */
void pmStopSingle(void)
{
	isPrimeThreadSingle = FALSE;
}

/* ------------------------------------------------------------------------------------------------------
	PXbhĂ邩
------------------------------------------------------------------------------------------------------ */
BOOL pmIsPrimeThreadSingle(void)
{
	return isPrimeThreadSingle;
}

/* ------------------------------------------------------------------------------------------------------
	ݒl
------------------------------------------------------------------------------------------------------ */
static void pmWriteNow(ULONGLONG nNow, ULONGLONG nCount)
{
	WritePrivateProfileInt64(PM_APP, PM_KEY_NOW  , nNow  , PM_SETFILE);
	WritePrivateProfileInt64(PM_APP, PM_KEY_COUNT, nCount, PM_SETFILE);
}

/* ------------------------------------------------------------------------------------------------------
	 64bit
------------------------------------------------------------------------------------------------------ */
ULONGLONG pmSqrt64(ULONGLONG x)
{
  ULONGLONG s, t;

  if (x <= 0) return 0;

  s = 1;  t = x;
  while (s < t) {  s <<= 1;  t >>= 1;  }
  do {
    t = s;
    s = (x / s + s) >> 1;
  } while (s < t);

  return t;
}

/* ------------------------------------------------------------------------------------------------------
	f
	0 iXbhIj
	1 
	2 Ȃ
------------------------------------------------------------------------------------------------------ */
static int pmIsPrime(ULONGLONG nPrime)
{
	int ret=0;
	ULONGLONG max;
	ULONGLONG n;

	max = pmSqrt64( nPrime );  // GgXelX̂ӂ邢
	for(n=3; n<=max && isPrimeThread; n+=2)
	{
		if( (nPrime % n) == 0 )
		{
			ret = 1;
			break;
		}
		Sleep(0);
	}

	if( ret==0 && isPrimeThread ) ret = 2;
	return ret;
}

/* ------------------------------------------------------------------------------------------------------
	XbhX^[g
------------------------------------------------------------------------------------------------------ */
static void pmSearch(void* pParam)
{
	HWND hwnd = (HWND)pParam;
	char szData[256]="";
	int ret;

	FILE* fp = fopen(PM_FILE, "a");

	// 22ɂ
	if( nPrimeNow < 2 ) nPrimeNow = 2;
	// 2͑f
	if( nPrimeNow == 2 )
	{
		_ui64toa(nPrimeNow, szData, 10);
		fputs(szData, fp);
		fputs("\n", fp);
		nPrimeCount++;
		nPrimeNow++;
	}
	// Ȃ1i߂
	if( (nPrimeNow % 2) == 0 )
		nPrimeNow++;

	for(;;)
	{
		_ui64toa(nPrimeNow, szData, 10);
		SetDlgItemText(hwnd, IDC_NOW, szData);
		ret = pmIsPrime( nPrimeNow );
		if( ret==2 )
		{
			// fł
			fputs(szData, fp);
			fputs("\n", fp);
			nPrimeCount++;
			_ui64toa(nPrimeCount, szData, 10);
			SetDlgItemText(hwnd, IDC_COUNT, szData);
			nPrimeNow += 2;
		}
		else if( ret==1 )
		{
			// fȂ
			nPrimeNow += 2;
		}
		else
		{
			// 
			break;
		}
	}
	pmWriteNow(nPrimeNow, nPrimeCount);

	fclose(fp);
	isPrimeThread = FALSE;
	return;
}


/* ------------------------------------------------------------------------------------------------------
	PfXbh
------------------------------------------------------------------------------------------------------ */
static void pmSearchSingle(void* pParam)
{
	HWND hwnd;
	char szData[256]="";
	ULONGLONG nPrime=0;
	ULONGLONG max=0;
	ULONGLONG n=0;

	hwnd = (HWND)pParam;

	SetDlgItemText(hwnd, IDC_CHECK, "~(&C)");
	SetDlgItemText(hwnd, IDC_RESULT, "蒆...");

	GetDlgItemText(hwnd, IDC_PRIME, szData, sizeof(szData));
	nPrime = _strtoui64(szData, NULL, 10);
	_ui64toa(nPrime, szData, 10);
	SetDlgItemText(hwnd, IDC_PRIME, szData);

	// f
	BOOL ret=FALSE;
	do
	{
		if( nPrime < 2 )
		{
			strcpy(szData, "fȂB");
			ret = TRUE;
			break;
		}
		if( nPrime == 2 )
		{
			ret = FALSE;
			break;
		}
		if( (nPrime % 2) == 0 )
		{
			strcpy(szData, "2 ŊꂽBfȂB");
			ret = TRUE;
			break;
		}

		max = pmSqrt64( nPrime );  // GgXelX̂ӂ邢
		for(n=3; n<=max && isPrimeThreadSingle; n+=2)
		{
			if( (nPrime % n) == 0 )
			{
				_ui64toa(n, szData, 10);
				strcat(szData, " ŊꂽBfȂB");
				ret = TRUE;
				break;
			}
			Sleep(0);
		}
	}while(0);

	if( isPrimeThreadSingle )
	{
		if( !ret ) strcpy(szData, "fłB");
	}
	else
	{
		strcpy(szData, "~܂B");
	}
	SetDlgItemText(hwnd, IDC_RESULT, szData);
	SetDlgItemText(hwnd, IDC_CHECK, "(&C)");

	isPrimeThreadSingle = FALSE;
	return;
}
